#include "Status.h"
#include "Vram.h"
#include "VVram.h"
#include "Main.h"
#include "Chars.h"
#include "Print.h"
#include "Knife.h"

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p)
{
    byte c;
    while ((c = *p) != 0) {
        pVram = PrintC(pVram, c);
        ++p;
    }
    return pVram;
}

void PrintStatus()
{
    PrintS(VramFrontOrg + VVramWidth * VramStep, "SCORE");
    PrintS(VramFrontOrg + VramRowSize * 3 + VVramWidth * VramStep, "STAGE");
    PrintByteNumber2(VramFrontOrg + VramRowSize * 4 + (VVramWidth + 4) * VramStep, CurrentStage + 1);
    PrintS(VramFrontOrg + VramRowSize * 6 + VVramWidth * VramStep, "TIME");
    {
        constexpr ptr<byte> RemainLeft = VramFrontOrg + VramRowSize * (VramHeight - 2) + (VVramWidth + 1) * VramStep;
        ptr<byte> pVram;
        byte count;
        pVram = RemainLeft;
        for (count = 1; count < RemainCount; ++count) {
            pVram = Put2C(pVram, Char_Man);
        }
    }
    PrintScore();
    PrintTime();
    PrintHeldKnives();
}

void PrintScore()
{
    ptr<byte> pVram;
    pVram = PrintNumber5(VramFrontOrg + VramRowSize + VVramWidth * VramStep, Score);
    PrintC(pVram, '0');
}

void PrintTime()
{
    PrintNumber3(VramFrontOrg + VramRowSize * 7 + (VVramWidth + 3) * VramStep, StageTime);
}

void PrintHeldKnives()
{
    ptr<byte> pVram;
    byte count, i;

    pVram = VramFrontOrg + VramRowSize * (VramHeight - 4) + (VVramWidth + 1) * VramStep;
    i = 0;
    count = HeldKnifeCount;
    while (count != 0) {
        pVram = Put(pVram, Char_Kn_Left);
        ++i;
        --count;
    }
    while (i != 4) {
        pVram = Put(pVram, Char_Space);
        ++i;
    }
}

void PrintGameOver()
{
    PrintS(VramFrontOrg + VramRowSize * 8 + (VVramWidth - 9) / 2 * VramStep, "GAME OVER");
}

void PrintTimeUp() 
{
    PrintS(VramFrontOrg + VramRowSize * 8 + (VVramWidth - 7) / 2 * VramStep, "TIME UP");
}


void Title()
{
    ClearScreen(); 
    PrintStatus();
    {
        static const byte[] TitleBytes = {
            0x4f, 0x4d, 0x4d, 0x42, 
            0x48, 0x4f, 0x42, 0x44, 
            0x45, 0x4d, 0x43, 0x4f, 
            0x40, 0x4f, 
            0x4f, 0x4c, 0x4c, 0x43, 
            0x4f, 0x40, 0x4f, 0x40, 
            0x48, 0x47, 0x40, 0x4d, 
            0x4a, 0x47, 
            0x4f, 0x4c, 0x4c, 0x43, 
            0x4f, 0x45, 0x4f, 0x48, 
            0x47, 0x40, 0x40, 0x40, 
            0x4f, 0x40, 
            0x45, 0x44, 0x44, 0x41, 
            0x45, 0x40, 0x45, 0x44, 
            0x45, 0x45, 0x41, 0x40, 
            0x45, 0x40, 
        };
        constexpr byte LogoWidth = 14;
        ptr<byte> p;
        ptr<byte> pVram;
        pVram = VramFrontOrg + VramRowSize * 4 + (14 - LogoWidth) / 2 * VramStep;
        p = TitleBytes;
        repeat (4) {
            repeat (LogoWidth) {
                pVram = Put(pVram, *p);
                ++p;
            }
            pVram += VramRowSize - LogoWidth * VramStep;
        }
        PrintS(VramFrontOrg + VramRowSize * 8 + ((14 + LogoWidth) / 2 - 4) * VramStep, "MINI");
    }
    PrintS(VramFrontOrg + VramRowSize * 14 + 0 * VramStep, "PUSH START");
    PrintS(VramFrontOrg + VramRowSize * 15 + 8 * VramStep, "BUTTON");
    PrintS(VramFrontOrg + VramRowSize * 17 + 2 * VramStep, "INUFUTO 2023");
}
