include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext VVram_
ext BaseX_, BaseY_, Map_

MapStep equ 8

; ptr<byte> VVramPtr(byte x, byte y);
cseg
VVramPtr_: public VVramPtr_
    push dx
        mov dh,al
        mov al,VVramWidth | mul dl
        mov dl,dh
        xor dh,dh
        add ax,dx
        add ax,VVram_
    pop dx
ret


; void MapToVVram();
cseg
MapToVVram_: public MapToVVram_
    push ax | push cx | push dx | push si | push di
        mov al,[BaseY_]
        mov ah,8 | mul ah
        add ax,Map_
        mov si,ax
        mov al,[BaseX_]
        mov dh,al
        shr al,1 | shr al,1 | shr al,1
        xor ah,ah
        add si,ax
        mov dl,1
        and dh,7
        do | while nz
            shl dl,1
            dec dh
        wend
        mov di,VVram_
        mov ch,VVramHeight
        do
            push dx | push si
                mov cl,VVramWidth
                mov dh,[si] | inc si
                do
                    test dh,dl
                    if ne
                        mov al,Char_Wall
                    else
                        xor al,al
                    endif
                    mov [di],al | inc di
                    rol dl,1
                    if c
                        mov dh,[si] | inc si
                    endif
                    dec cl
                while nz | wend
            pop si | pop dx
            add si,MapStep
            dec ch
        while nz | wend
    pop di | pop si | pop dx | pop cx | pop ax
ret
